ghc-7.0.3: The GHC API

Unify

# Documentation

tcMatchTy :: TyVarSet -> Type -> Type -> Maybe TvSubst

tcMatchTys :: TyVarSet -> [Type] -> [Type] -> Maybe TvSubst

tcMatchTyX :: TyVarSet -> TvSubst -> Type -> Type -> Maybe TvSubst

ruleMatchTyX :: MatchEnv -> TvSubstEnv -> Type -> Type -> Maybe TvSubstEnv

tcMatchPreds :: [TyVar] -> [PredType] -> [PredType] -> Maybe TvSubstEnv

data MatchEnv

Constructors

ME |

Fields

me_tmpls :: VarSet
me_env :: RnEnv2

dataConCannotMatch :: [Type] -> DataCon -> Bool

tcUnifyTys :: (TyVar -> BindFlag) -> [Type] -> [Type] -> Maybe TvSubst

data BindFlag

Constructors

BindMe |
Skolem |

niFixTvSubst :: TvSubstEnv -> TvSubst

niSubstTvSet :: TvSubstEnv -> TyVarSet -> TyVarSet